#include "EvilNetw.h"
Define_Module(EvilNetw);

// Initializes EvilNetw module
void EvilNetw::initialize(int stage){ 
	WiseRoute::initialize(stage);
	if(stage == 1) {
		nbDataPacketsDropped = 0;
	}
}
// Finalize module and record statistics
void EvilNetw::finish(){
	WiseRoute::finish();
	if (stats) {
		recordScalar("nbDataPacketsDropped", nbDataPacketsDropped);
	}
}
// Handle message from lower (MAC) layer
void EvilNetw::handleLowerMsg(cMessage* msg) {
	// Consider only DATA packets and drop only with certain probability
	if (msg->getKind()==DATA && par("pDataPacketDropping").doubleValue()>=uniform(0,1)){			
		getNode()->bubble("Dropping a packet!"); // notification
		EV << "Dropping a packet!" << endl; // logging
		nbDataPacketsDropped++; // statistics
		delete msg; msg = NULL; return;
	}
	WiseRoute::handleLowerMsg(msg); // fallback
}
